﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using WMPLib;
/*
 *  Playlist printer by Michl 
 *  http://michlstechblog.info
 *  License: GPLv2
 *  Feel free to modify!
 *  If you modify or improve it please 
 *  share to the community!
 * 
 */
namespace WindowsFormsApplication1
{
    public partial class MediaPlayerExport : Form
    {
        private IWMPPlaylistArray aPlayLists;
        private String sCSVExport="";
        private String sLoadedPlayList = "";
        public string sCSS = @"
                <style type=""text/css"">
                    body {font-family:Tahoma,Verdana,Arial,Helvetica;font-size:12px;}
                    h2 {font-size:12px;}
                    td,th,tr {font-size:10px;}
                    tr{background-color:#eeeeee;}
                    th{background-color:#cccccc;font-weight:bold;text-align:left;}
                    .tdlineodd {background-color:#ffffff;}
                    .tdlineeven {background-color:#eeeeee;}
                    .playlisttable {border: solid 1px #ffffff;}
                </style>";
        public string sHTMLBody = "";
        public MediaPlayerExport()
        {
            InitializeComponent();
        }

        private void MediaPlayerExport_Load(object sender, EventArgs e)
        {
            WMPLib.IWMPPlaylistCollection oPlayList = axWindowsMediaPlayer1.playlistCollection;
            aPlayLists = oPlayList.getAll();
            System.Diagnostics.Debug.Print("Playlistcount: " + aPlayLists.count);
            listBoxPlaylist.Items.Clear();
            for (System.Int32 iLoop = 0; iLoop < aPlayLists.count;iLoop++ )
            {
                listBoxPlaylist.Items.Add(aPlayLists.Item(iLoop).name);
                //System.Diagnostics.Debug.Print(aPlayLists.Item(iLoop).name);
                //IWMPPlaylist oList=aPlayLists.Item(iLoop);
                //for (System.Int32 jLoop = 0; jLoop < oList.count; jLoop++) {
                //    IWMPMedia oTitle = oList.Item[jLoop];
                //    System.Diagnostics.Debug.Print("MEDIA:" + oTitle);
                //    for (Int32 kLoop=0; kLoop < oTitle.attributeCount; kLoop++) {
                //        System.Diagnostics.Debug.Print("ATTRIBUTE:" + oTitle.getAttributeName(kLoop)+"="+oTitle.getItemInfo(oTitle.getAttributeName(kLoop)));
                //    }

                //}
            }
            webBrowserControl.DocumentText = "<html>" + sCSS + "<body><h2>Playlist Printer by Michl <a target=_blank href=\"http://michlstechblog.info\">http://michlstechblog.info</a> </h2><br><br>Select a playlist and press \"Load playlist\"</body></html>";
        }

        private void MediaPlayerExport_Resize(object sender, EventArgs e)
        {
            axWindowsMediaPlayer1.Width = this.Size.Width-16;
        }

        private void listBoxPlaylist_DoubleClick(object sender, EventArgs e)
        {
            fLoadPlayList();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            webBrowserControl.ShowPrintPreviewDialog();
        }
        public void fLoadPlayList(){
            //System.Diagnostics.Debug.Print(listBoxPlaylist.SelectedItem.ToString());
            //IWMPPlaylist oList = aPlayLists.Item(listBoxPlaylist.SelectedIndex);
            sCSVExport = "";
            if (listBoxPlaylist.SelectedIndex == -1) { 
                MessageBox.Show("Choose a playlist please.","Attention");
            }
            else
            {
                this.Cursor = System.Windows.Forms.Cursors.WaitCursor;
                IWMPPlaylist oList = aPlayLists.Item(listBoxPlaylist.SelectedIndex);
                for (System.Int32 jLoop = 0; jLoop < oList.attributeCount; jLoop++)
                {
                    System.Diagnostics.Debug.Print("ATTR:" + oList.attributeName[jLoop] + "=" + oList.getItemInfo(oList.attributeName[jLoop]));
                }
                sHTMLBody = "<h3>Playlist: " + oList.name + "</h3>";
                sLoadedPlayList = oList.name;
                sHTMLBody +="<table class=\"playlisttable\"><tbody>";
                sHTMLBody += "<tr>";
                if (checkBoxIndex.Checked)
                {
                    sHTMLBody += "<th class=\"thclass\">Track</th>";
                    sCSVExport += "Track;";
                }
                if (checkBoxInterpret.Checked)
                {
                    sHTMLBody += "<th class=\"thclass\">Artist</th>";
                    sCSVExport += "Artist;";
                }
                if (checkBoxTitle.Checked)
                {
                    sHTMLBody += "<th class=\"thclass\">Title</th>";
                    sCSVExport += "Title;";
                }
                if (checkBoxAlbum.Checked)
                {
                    sHTMLBody += "<th class=\"thclass\">Album</th>";
                    sCSVExport += "Album;";
                }
                if (checkBoxLaenge.Checked)
                {
                    sHTMLBody += "<th class=\"thclass\">Length</th>";
                    sCSVExport += "Length;";
                }
                sHTMLBody += "</tr>";
                sCSVExport += "\n";
                for (System.Int32 jLoop = 0; jLoop < oList.count; jLoop++) {
                    IWMPMedia oTitle = oList.Item[jLoop];
                    System.Diagnostics.Debug.Print("MEDIA:" + oTitle.getItemInfo("WM/AlbumArtist") + " " + oTitle.getItemInfo("Title"));
                    string trClass="";
                    string tdClass="";
                    if (jLoop % 2 == 0)
                    {
                        trClass="trlineodd";
                        tdClass = "tdlineodd";
                    }
                    else {
                        trClass = "trlineeven";
                        tdClass = "tdlineeven";
                    }
                    sHTMLBody += "<tr class=\""+trClass+"\">";
                    if (checkBoxIndex.Checked) {
                        sHTMLBody += "<td class=\"" + tdClass + "\">" + (jLoop+1).ToString() + "</td>";
                        sCSVExport += (jLoop+1).ToString()+";";
                    }
                    if (checkBoxInterpret.Checked)
                    {
                        sHTMLBody += "<td class=\"" + tdClass + "\">" + oTitle.getItemInfo("Author") + "</td>";
                        if (oTitle.getItemInfo("Author").IndexOf(";") >= 0)
                        {
                            sCSVExport += "\"" + oTitle.getItemInfo("Author") + "\";";
                        }
                        else {
                            sCSVExport += oTitle.getItemInfo("Author") + ";";
                        }
                    }
                    if (checkBoxTitle.Checked)
                    {
                        sHTMLBody += "<td class=\"" + tdClass + "\">" + oTitle.getItemInfo("Title") + "</td>";
                        if (oTitle.getItemInfo("Title").IndexOf(";") >= 0)
                        {
                            sCSVExport += "\"" + oTitle.getItemInfo("Title") + "\";";
                        }
                        else
                        {
                            sCSVExport += oTitle.getItemInfo("Title") + ";";
                        }
                    }
                    if (checkBoxAlbum.Checked )
                    {
                        sHTMLBody += "<td class=\"" + tdClass + "\">" + oTitle.getItemInfo("WM/AlbumTitle") + "</td>";
                        if (oTitle.getItemInfo("WM/AlbumTitle").IndexOf(";") >= 0)
                        {
                            sCSVExport += "\"" + oTitle.getItemInfo("WM/AlbumTitle") + "\";";
                        }
                        else
                        {
                            sCSVExport += oTitle.getItemInfo("WM/AlbumTitle") + ";";
                        }
                    }
                    if (checkBoxLaenge.Checked)
                    {
                        TimeSpan oTime;
                        String sLength;
                        try
                        {
                            oTime = new TimeSpan(System.Convert.ToInt64(System.Convert.ToDecimal(oTitle.getItemInfo("Duration")) * 10000000));
                            sLength = System.Decimal.Truncate(System.Convert.ToDecimal(oTime.TotalMinutes)) + ":" + System.Decimal.Truncate(System.Convert.ToDecimal(oTime.Seconds)).ToString("00", System.Globalization.CultureInfo.CurrentCulture);
                        }
                        catch { 
                            sLength=oTitle.getItemInfo("DurationString");
                        }
                        sHTMLBody += "<td class=\"" + tdClass + "\">" + sLength  + "</td>";
                        //sCSVExport += System.Decimal.Truncate(System.Convert.ToDecimal(oTime.TotalMinutes)) + ":" + System.Decimal.Truncate(System.Convert.ToDecimal(oTime.Seconds)).ToString("00", System.Globalization.CultureInfo.CurrentCulture) + ";";
                        sCSVExport+=sLength+";";
                    }
                    sHTMLBody +=@"</tr>";
                    sCSVExport += "\r\n";
                    /*for (Int32 kLoop=0; kLoop < oTitle.attributeCount; kLoop++) {
                        System.Diagnostics.Debug.Print("ATTRIBUTE:" + oTitle.getAttributeName(kLoop)+"="+oTitle.getItemInfo(oTitle.getAttributeName(kLoop)));
                    }*/

                }
                sHTMLBody += @"</tbody></table>";
                webBrowserControl.DocumentText = "<html>" + sCSS + "<body>"+sHTMLBody+"</body></html>";
                this.Cursor = System.Windows.Forms.Cursors.Default;
                buttonCSVExport.Enabled = true;
            }

        }

        private void buttonLoadList_Click(object sender, EventArgs e)
        {
            fLoadPlayList();
        }

        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {

        }

        private void buttonCSVExport_Click(object sender, EventArgs e)

        {
            if (sLoadedPlayList.IndexOfAny(System.IO.Path.GetInvalidFileNameChars()) < 0)
            {
                saveFileCSV.FileName = sLoadedPlayList + ".csv";
            }
            else
            {
                saveFileCSV.FileName = "MediaPlayer Playlist .csv";
            }
            if (saveFileCSV.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                try
                {
                    System.IO.File.WriteAllText(saveFileCSV.FileName, sCSVExport, System.Text.Encoding.UTF8);
                }
                catch(Exception oEx)
                {
                    MessageBox.Show("Error writing file " + saveFileCSV.FileName + " Error:" + oEx.Message, "Achtung");
                }
            }
        }
    }
}

